library(sn)
library(mvtnorm)
data(ais)
set.seed(1)

#d=ais[,c("bmi","Bfat","ssf","lbm")]
d=log(ais[,c("rcc","wcc","Hg")])
names(d)=c("log(rcc)","log(wcc)","log(hg)")
#d=log(ais[,c("rcc","wcc","Fe")])
#names(d)=c("log(rcc)","log(wcc)","log(Fe)")

#pdf("aisplot.pdf",width=6,height=6)
postscript("aisplot.ps",width=6,height=6,horizontal=FALSE,paper="special")
plot(log(d))
dev.off()

## standardize by mean and std.dev.
mns=sapply(d,mean)
sds=sapply(d,sd)
d2=data.frame((d[,1]-mns[1])/sds[1],(d[,2]-mns[2])/sds[2],(d[,3]-mns[3])/sds[3])
names(d2)=names(d)

B=999

## females
#choose=(ais$sex=="female")
## males
#choose=(ais$sex=="male")
## vsichni
choose=rep(TRUE,nrow(d))

# w=1
sph3d <- function (x,u,a=1,...) { # this should be a bit faster...
    .C("sph3d1",x1=as.double(x[,1]),x2=as.double(x[,2]),x3=as.double(x[,3]),u1=as.double(u[,1]),u2=as.double(u[,2]),u3=as.double(u[,3]),n=as.integer(nrow(x)),k=as.integer(nrow(u)),a=as.double(a),t=double(1))$t
  }
dyn.load("./sph3d1.so")

#sablona3d=function(k1=4) {
#  u=NULL
#  ##colors=NULL
#  ##  u=rbind(c(1,0,0),c(-1,0,0))
#  ##  colors=c(0,0)
#  ## regular grid on (0,pi) for phi1
#  ## regular grid on (0,2*pi) for phi2 but the number of points proportional to 2*sin^2(phi1)
#  for (phi1 in pi*(1:k1)/(k1+1)) {
#    npts=round(2*((sin(phi1))^2)*k1)
#    for (phi2 in 2*pi*(1:(npts)/(npts))) {
#      u=rbind(u,c(cos(phi1),sin(phi1)*cos(phi2),sin(phi1)*sin(phi2)))
#      colors=c(colors,phi1)
#    }
#  }
#  ##colors=as.numeric(factor(colors))
#  return(u)
#}
ntnet=function(n=11) {
  ens=seq(5,31,by=2)
  h2s=c(2,3,4,7,5,11,5,14,13,9,7,16,23,21)
  h2=h2s[which(ens==n)]
  h1=1
  ## mame n, h1 a h2 pro NT-net
  cki=matrix(NA,nrow=n,ncol=2)
  qk1=((1:n)*h1)%%n 
  qk2=((1:n)*h2)%%n 
  qk1=qk1+n*(qk1==0)#nuly nahradit n
  qk2=qk2+n*(qk2==0)#nuly nahradit n
  cki[,1]=(2*qk1-1)/(2*n)
  cki[,2]=(2*qk2-1)/(2*n)
  ## ted spocitame xki podl knihy
  xki=matrix(NA,nrow=n,ncol=3)
  xki[,1]=1-2*cki[,1]
  xki[,2]=2*sqrt((cki[,1])*(1-cki[,1]))*cos(2*pi*cki[,2])
  xki[,3]=2*sqrt((cki[,1])*(1-cki[,1]))*sin(2*pi*cki[,2])
  u=xki
  return(u)
}

#a=0.7 # doporucena hodnota pro norm. rozd a w=1
a=0.4 # podle Simose

#u=sablona3d(4) # this is now set in "zadani"
u=ntnet(21)
x=d2
n=nrow(x)
dx=sqrt(apply(x^2,1,sum))
  ## calculate the test statistic
#  ts=sphtst1(x,k=k,a=a)
ts=sph3d(x,u,a=a,kruhu=kruhu,rmax=rmax)
nb=1
for (b in 1:B) {
  ## generate x.b (sphered)
  ## generate random vectors of length 1
  rv=rmvnorm(n,mean=c(0,0,0))
  ##
  ts.b=sph3d(dx*rv/sqrt(apply(rv^2,1,sum)),u,a=a,kruhu=kruhu,rmax=rmax)
  nb = nb + (ts.b>=ts)
}
pb=nb/(B+1)
## reject if pvalue<alpha

print("3D test - w=1")
print(pb)

## 2d cases
sphtst1 <- function (x,k,a) { # this should be a bit faster...
  .C("sphtst1",x1=as.double(x[,1]),x2=as.double(x[,2]),n=as.integer(nrow(x)),k=as.integer(k),a=as.double(a),t=double(1))$t
}
dyn.load("./sphtst1.so")


#a=0.7
a=0.4
k=17

for (i in 1:2) {
  for (j in (i+1):3) {
    x=d2[choose,c(i,j)]
    ## calculate the value of the test statistic
    ts=sphtst1(x,k=k,a=a)
    ## run the bootstrap replicates
    nb=1
    for (b in 1:B) {
      ## generate x.b (sphered)
      ## generate random vectors of length 1
      u=2*pi*runif(n)
      ##
      ts.b=sphtst1(cbind(cos(u)*dx,sin(u)*dx),k=k,a=a)
      nb = nb + (ts.b>=ts)
    }
    pb=nb/(B+1)
    print(paste(i,j,names(d)[i],names(d)[j]," ts",ts," p-value",pb))
  }
}


