#include <math.h>
#define PI 3.141592653589793238462643
void sphtst2(double *x1, double *x2, int *n, int *k, double *a, double *t) 
{
  int it, is, l, m;
  double intg, t1, t2, u1[*k], u2[*k];
  /* regular grid on angles (k should be odd), v=-u for the other set of angles */
  for(it = 0; it < *k; it++) 
    {
      u1[it] = cos(2.0 * PI * (it + 1.0) / *k);
      u2[it] = sin(2.0 * PI * (it + 1.0) / *k);
    }
  /* scaling by a */
  t1 = 1.0 / (2.0 * sqrt( *a ));
  for(l = 0; l < *n; l++) 
    {
      x1[l] = t1 * x1[l] ;
      x2[l] = t1 * x2[l] ;
    }
  /* starting value */
  intg = 2.0 * *n * *k * *k; 
  /* calculate the sum */
  for(it = 0; it < *k ; it++) 
    {
      for(l = 0; l < (*n-1); l++)
	{
	  for( m = l+1; m < *n; m++) 
	    {
	      t1 = u1[it] * (x1[l]-x1[m]) + u2[it] * (x2[l]-x2[m]);
	      t2 = u1[it] * (x1[l]+x1[m]) + u2[it] * (x2[l]+x2[m]) ;
	      intg +=  4.0  * exp ( (-1.0) * t1 *t1) - 4.0  * exp ( (-1.0) * t2 *t2) ; 
	    }
	  t1 = 2.0*(u1[it]* x1[l] + u2[it] * x2[l]) ;
	  intg += (-2.0) * exp ( (-1.0) * t1 *t1);
	}
      t1 = 2.0*(u1[it]* x1[*n -1] + u2[it] * x2[*n -1]) ;
      intg += (-2.0) * exp ( (-1.0) * t1 *t1);
    }
  for(it = 0; it < (*k - 1) ; it++) 
    {
      for(l = 0; l < (*n - 1); l++)
	{
	  for( m = (l+1); m < *n; m++) 
	    {
	      t1 = u1[it] * (x1[l]-x1[m]) + u2[it] * (x2[l]-x2[m]);
	      intg += 4.0 * (*k - 1.0) * exp ( (-1.0) * t1 *t1); 
	    }
	}
      for(is = (it+1); is < *k ; is++)
	{
	  for(l = 0; l < (*n-1); l++)
	    {
	      for( m = (l+1); m < *n; m++) 
		{
		  t1 = u1[it] * x1[l] + u2[it]*x2[l] + u1[is] * x1[m] + u2[is]*x2[m] ;
		  t2 = u1[is] * x1[l] + u2[is]*x2[l] + u1[it] * x1[m] + u2[it]*x2[m] ;
		  intg += (-4.0) * exp ( (-1.0) * t1 *t1) - 4.0 * exp ( (-1.0) * t2 *t2); 
		}
	      t2 = (u1[it]+u1[is]) * x1[l] + (u2[it]+u2[is]) * x2[l] ; 
	      intg += (-4.0) * exp ( (-1.0) * t2 *t2); 
	    }
	  t2 = (u1[it]+u1[is]) * x1[*n-1] + (u2[it]+u2[is]) * x2[*n-1] ;
	  intg += (-4.0) * exp ( (-1.0) * t2 *t2); 
	}
    }
  for(l = 0; l < (*n-1); l++)
    {
      for( m = (l+1); m < *n; m++) 
	{
	  t1 = u1[*k -1] * (x1[l]-x1[m]) + u2[*k - 1] * (x2[l]-x2[m]) ; 
	  intg += 4.0 * (*k - 1.0) * exp ( (-1.0) * t1 *t1); 
 	}
    }
  /* divide the sum by a constant to obtain the test statistic */
  *t = sqrt(PI / *a)  * intg / (2.0 * *n) ;
}
